clear all
y0=2; T=1;
dt=[1e0 1e-1 1e-2 1e-3];
g='2./(1+t.^2)'; %la soluzione esatta

%metodo di Eulero esplicito
for i=1:4, 
     t=[0:dt(i):T]; 
     N=length(t);      
     uEe=zeros(1,N);
     uEe(1)=y0; 
     for n=1:N-1
         uEe(n+1)=uEe(n)-dt(i)*t(n)*uEe(n)^2; 
         y=eval(g); 
         errEe(i)=max(abs(y-uEe)); 
     end 
end
%loglog(dt,errEe,'ro-')

%------------------------------------------
%metodo di Eulero implicito

for i=1:length(dt), 
     t=[0:dt(i):T]; 
     N=length(t);      
     uEi=zeros(1,N);
     uEi(1)=y0; 
     for n=1:N-1         
         fun=strcat('x+x.^2*',num2str(dt(i)*t(n+1),16),'-',num2str(uEi(n),16));         
         zero=fzero(fun,uEi(n));         
         uEi(n+1)=zero;         
     end    
         y=eval(g); 
         errEi(i)=max(abs(y-uEi));          
end
%loglog(dt,errEi,'bo-')

%--------------------------------------------
%metodo di CrankNicholson

for i=1:length(dt), 
     t=[0:dt(i):T]; 
     N=length(t);      
     uCN=zeros(1,N);
     uCN(1)=y0; 
     for n=1:N-1         
         fun=strcat('x+x.^2*',num2str(dt(i)/2*t(n+1),16),'-',num2str(uCN(n),16),'+',num2str(dt(i)/2*t(n)*uCN(n)^2));
         zero=fzero(fun,uCN(n));         
         uCN(n+1)=zero;         
     end    
         y=eval(g); 
         errCN(i)=max(abs(y-uCN));          
end
%loglog(dt,errCN,'go-')

%----------------------------------------------
%il grafico ddella soluzione esatta,uEe,uEi,uCN
%per t=[0:dt(length(dt)):T];
figure(2)
plot(t,y,'k',t,uEe,'r',t,uEi,'b',t,uCN,'g');
legend('Soluzione esatta','Eulero esplicito','Eulero implicito','Cranck-Nicholson',-1);

print -dpsc figure2




figure(3)
xr=[1e-1,1e0];
yr1=[1e-7  1e-6];
yr2=[1e-7  1e-5];
loglog(dt,errEe,'ro-',dt,errEi,'bo-',dt,errCN,'go-',xr,yr1,'r:',xr,yr2,'g:');
legend('Eulero esplicito','Eulero implicito','Cranck-Nicholson','reta di rif. pendenza 1','reta di rif. pendenza 2',-1);
print -dpsc figure3
