function [tn, yn] = eulesp (t0, y0, tf, h, f)
%
%    Metodo di eulero esplicito
%
%        [tn, yn] = eulesp (t0, y0, tf, h, f)
%
% Parametri in ingresso
%   t0, y0  condizioni iniziali (u_0 = y0(t0))
%   tf      estremo di integrazione
%   h       passo di integrazione
%   f       macro contenente la funzione del problema di Cauchy
% 
% Parametri in uscita
%  tn       ascisse di valutazione
%  yn  valori della soluzione calcolata
%
clear tn yn

n=fix(abs(tf-t0)/h);
tn(1) = t0;
yn(1) = y0;

for i=2:n
    t = tn(i-1);
    y = yn(i-1);
    yf = eval(f);    
    tn(i) = t + h;
    yn(i) = y + h * yf;
end
return
