function [xnodes, fnodes, x, fx, px]= qssinterpol(a, b, n, inod, fun)
%
%        [xnodes, fnodes, x, fx, px]= qssinterpol(a, b, n, inod, fun)
%        Genera il polinomio interpolatore Pi_n(f) di grado n 
%        (n >= 1) della funzione f(x) su [a,b]. E' possibile utilizzare: 
%
%	 1) nodi equispaziati 
%	 2) nodi di Gauss-Chebyshev
%        
%	 inod : 1 per nodi equispaziati, 2 per nodi di Chebyshev
%        fun : stringa contenente la funzione interpolanda        
%        x, fx, px : vettore di valutazione delle x e corrispondenti
%                    valori di f e di Pi_n(f)
%        xnodes, fnodes : nodi di interpolazione e valori nodali di f


h=(b-a)/n; 
if (inod==1)
   xnodes=[a:h:b]; 
else
   k=[0:n];
   t=-cos(((2*k+1)*pi)/(2*(n+1)));
   xnodes=((b-a)/2)*t+(a+b)/2;
end
x=xnodes;
fnodes=eval(fun); 
x=[a:1/1000:b];

fx=eval(fun);
px=qsslagrange(xnodes,fnodes,x);

plot(x,fx,'c',xnodes,fnodes,'*',x,px,'g');

return
