function px=qsslagrange(xnodes,fnodes,xv);
%
%	 Valuta il polinomio interpolatore 
%	 di Lagrange di f(x) in corrispondenza 
%	 dei punti xv.
%
%	 xnodes:   vettore colonna degli (n+1)
%	           nodi di interpolazione (distinti)
%	 fnodes:   vettore colonna degli (n+1) valori
%	           di f(x) nei nodi di interpolazione 
%	 xv    :   vettore colonna contenente le
%		   coordinate dei punti di valutazione
%	 px    :   vettore contenente il polin. interp.
%		   calcolato nei punti xv
%
%	 px=qsslagrange(xnodes,fnodes,xv)
%
n=max(size(xnodes));
m=max(size(xv));
px=[];
for j=1:m,
    x=xv(j);
    pxv=0;
    for i=1:n,
        den=1; num=1; 
        xn=xnodes(i);
        for k=1:n,
            if k~=i,
               num=num*(x-xnodes(k));
               den=den*(xn-xnodes(k));
            end
        end
        pxv=pxv+fnodes(i)*num/den;
    end
    px=[px, pxv];
end
