function [xvect,xdif,fx,it]=qssptofis(xv,nmax,toll,g,fun)
%
%  [xvect,xdif,fx,it]=qssptofis(xv,nmax,toll,g,fun)
%
%  Metodo di punto fisso del tipo x=g(x) 
%  per la risoluzione di un'equazione f(x)=0
%
%  Parametri di ingresso:
%
%  xv      Punto di partenza
%  nmax    Numero massimo di iterazioni
%  toll    Tolleranza sul test d'arresto
%  g       Macro contenenti la funzione di iterazione
%  fun     Macro contenente la funzione f(x)
%
%  Parametri di uscita:
%
%  xvect   Vett. contenente tutte le iterate calcolate
%          (l'ultima componente e' la soluzione)
%  xdif    Vett. contenente l'avanzamento tra due iterate
%  fx      Vett. contenente le valutazioni di 'fun' in 'xvect'
%  it      Iterazioni effettuate
%
err=1;
it=0;
xvect=[xv];
xdif=[0];
x=xv;
fx=eval(fun);
%
while it<nmax & err>toll
   x=xv;
   xn=eval(g);
   x=xv;
   fx=[fx; eval(fun)];
   err=abs(xn-xv);
   xdif=[xdif;err];
   xvect=[xvect;xn];
   it=it+1;
   xv=xn;
end
%  
dim=max(size(xvect));
fprintf(' \n Numero di Iterazioni : %d \n',it);
fprintf(' Radice calcolata     : %12.8f \n',xvect(dim));
%
return
